SystemOrganization addCategory: #'GBT-DSL_Forum'!

Object subclass: #GbtForumA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_Forum'!

!GbtForumA class methodsFor: 'example' stamp: 'hk 5/5/2017 19:10'!
exampleClear
	GbtBizAppServer clearStore; clear. 
! !

!GbtForumA class methodsFor: 'example' stamp: 'hk 6/6/2017 20:19'!
exampleRun
	(self new 
		ensureCompilation;
		forumAApp) open
! !

!GbtForumA methodsFor: 'example' stamp: 'hk 6/6/2017 20:20'!
ensureCompilation
	GbtBizAppServer default hasContexts ifFalse: 
		[self forumAApp]! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 3/23/2017 15:16'!
forumAApp  
	"(self new forumAApp) open" 

	^GbtPlainAC struct: 'ForumAApp' define: {
		{#aspect:on: . self forumACtx . #customer } .
		{#uiSpec:icon: . #GbtMainUI . #forumA} .
		"note - the icon name (#forumA) is also used as an internal uiKey. 
		The icon itself is not used in MainUI and may be missing"
		{#extent: . (1000 @ 800)}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 6/7/2017 10:49'!
forumACtx  
	"(self new forumACt) open" 

	^GbtPrimeListAC struct: 'ForumA' define: {
		{#displayAs: . 'ForumAList'} .
		{#noPolicyPrefix: . 'Forum'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self forumAItem} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(Name forumName)  category threads messages views)} .
		{#subcontext: . self forumAItemCtx}}! !

!GbtForumA methodsFor: 'things' stamp: 'hk 7/16/2017 13:44'!
forumAItem
	"self new forumAItem edit"
	
	^GbtSmartThing struct: 'ForumAItem' define: {
		{ #Name . #val: . 'forum 1'}.
		{ #threads . #listOf: . self threadA}.
		{ #threadCount .  #calc: . 'sumTag (tcount)'}.
	} full: { 
		{ #category . #val: . 'cat 1'}.
		{ #messageCount .  #no: . 0}.
		{ #viewCount .  #no: . 0}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:13'!
forumAItemCtx  
	^GbtPlainAC struct: 'ForumAItemContext' define: {
		{#displayAs: . 'a Forum'  } .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #contacts }.
		{#aspect:on: . self threadsACtx . #threads } .
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:13'!
repliesACtx  
	^GbtUlistAC struct: 'RepliesAContext' define: {
		{#displayAs: . 'replies in a thread'  } .
		{#noPolicyPrefix: . 'Thread'}.
		{#template:for: . self replyA . #Replies }.
		{#subcontext: . self replyACtx}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts}.
	}! !

!GbtForumA methodsFor: 'things' stamp: 'hk 5/2/2017 16:47'!
replyA
	"self new replyA edit"
	
	^GbtSmartThing struct: 'ReplyA' define: {
		{ #Id . #val: . ''}.
		{ #ReplyDataTime . #val: . ''}.
	} full: { 
		{ #PostedBy . #val: . ''}.
		{ #Message .  #val: . ''}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:13'!
replyACtx  
	^GbtPlainAC struct: 'ReplyAContext' define: {
		{#displayAs: . 'reply'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
	}! !

!GbtForumA methodsFor: 'things' stamp: 'hk 7/16/2017 13:44'!
threadA
	"self threadA edit"
	^GbtSmartThing struct: 'ThreadA' define: {
		{ #ForumName . #calc: . 'ref (#R:Name)'}.
		{ #Subject . #val: . ''}.
		{ #Replies . #listOf: . self replyA}.
		{ #tcount . #no: . 1 }
	} full: { 
		{ #LastPostedBy . #val: . ''}.
		{ #Message .  #val: . ''}.
		{ #replies .  #no: . 0}.
		{ #views .  #no: . 0}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:13'!
threadACtx  
	^GbtPlainAC struct: 'ThreadAContext' define: {
		{#displayAs: . 'thread'  } .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #contact}.
		{#aspect:on: . self repliesACtx . #replies } .
	}
	! !

!GbtForumA methodsFor: 'contexts' stamp: 'hk 3/22/2017 13:13'!
threadsACtx  
	^GbtUlistAC struct: 'ThreadsAContext' define: {
		{#displayAs: . 'discussion threads'  } .
		{#noPolicyPrefix: . 'Thread'}.
		{#template:for: . self threadA . #threads }.
		{#subcontext: . self threadACtx }.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts}.
	}! !

Object subclass: #GbtForumB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_Forum'!
